The purpose of this document is to give interested users a look into what may come in future releases.

* Tracking custom query types - Trackable currently supports tracking filter, sort, and similar query types which operate on an array, but there are other possible query types that are not easily supported by the current Trackable infrastructure (e.g., mapping a collection to another collection). We are researching a solution to these cases and are hoping to develop a solution that works well for both client and server-based stores.
* A `refresh` event - We are considering adding a `refresh` event for a number of reasons. As we investigate adding support for tracking custom query types, it seems clear that some query types cannot be adequately maintained on a per-change basis on the client side. In those cases, emitting a `refresh` event may be the only practical way to respond to a change. In addition, adding a `refresh` event would allow data in a Memory store to be completely replaced via `Memory#setData`.
* Support for caching of fetched ranges (partial) may be added in future versions. Currently only full `fetch()` requests can fulfill a collection cache for future requests.